farmakami/urls.py
from django.contrib import admin
from django.urls import path,include
from login.views import welcome

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', welcome, name="homepage"),
    path('login/', include(('login.urls', 'login'), namespace='login')),
    path('bp/', include(('balaipengobatan.urls', 'bp'), namespace='bp')),
    path('obat/', include(('obat.urls', 'obat'), namespace='obat')),
    path('am/', include(('alat_medis.urls', 'am'), namespace='am')),
    path('transaksipembelian/', include(('transaksipembelian.urls', 'tp'), namespace='transaksipembelian')),
    path('list_produk_dibeli/', include(('list_produk_dibeli.urls', 'list_produk_dibeli'), namespace='list_produk_dibeli')),
    path('pengantaranfarmasi/', include(('pengantaranfarmasi.urls', 'pengantaranfarmasi'), namespace='pengantaranfarmasi')),
    path('Apotek/', include(('Apotek.urls', 'Apotek'), namespace='Apotek')),
    path('produkapotek/', include(('produkapotek.urls', 'produkapotek'), namespace='produkapotek')),
    path('transaksi_resep/', include(('transaksi_resep.urls', 'transaksi_resep'), namespace='transaksi_resep'))
]

login/urls.py
from django.urls import path, include
from .views import login, register_admin, register_konsumen, register_kurir, register_cs, validate, regchoice, homepage, alamat, hpalamat, logout, profile

app_name = "login"
urlpatterns = [
    path('login', login, name="login"),
    path('regadmin', register_admin, name="regadmin"),
    path('regkonsumen', register_konsumen, name="regkonsumen"),
    path('regkurir', register_kurir, name="regkurir"),
    path('regcs', register_cs, name="regcs"),
    path('regchoice', regchoice, name="regchoice"),
    path('homepage', homepage, name="homepage"),
    path('alamat/<id>/', alamat, name='alamat'),
    path('hpalamat/<id>/', hpalamat, name='hpalamat'),
    path('logout', logout, name='logout'),
    path('profile', profile, name='profile')
    # path('submitalamat/<id>/', submitalamat, name='submitalamat')
]

obat/urls.py
from django.urls import path, include
from .views import createobat, listobat, deleteobat, updateobat

app_name = "obat"
urlpatterns = [
    path('createobat', createobat, name="createobat"),
    path('listobat', listobat, name="listobat"),
    path('deleteobat/<id>/', deleteobat, name="deleteobat"),
    path('updateobat/<id>/', updateobat, name="updateobat")
]

pengantaranfarmasi/urls.py
from django.urls import path, include
from .views import createPF, listPF, updatePF, deletePF

app_name = "pengantaranfarmasi"
urlpatterns = [
    path('createPF', createPF, name="createPF"),
    path('listPF', listPF, name="listPF"),
    path('updatePF/<id>/', updatePF, name="updatePF"),
    path('deletePF/<id>/', deletePF, name="deletePF"),
]

pengantaranfarmasi/models.py
from django.db import models

# Create your models here.

pengantaranfarmasi/forms.py
from django import forms
import datetime
# from .widgets import BootstrapDateTimePickerInput

class PFForm(forms.Form):
    id_transaksi_pembelian = forms.CharField(label='ID Transaksi', max_length=10)
    waktu = forms.DateTimeField(input_formats=['%d/%m/%Y %H:%M'])
    biaya_kirim = forms.IntegerField(label='Biaya Kirim')


class updatePFForm(forms.Form):
    id_kurir =  forms.CharField(label='ID Kurir', max_length=10, required=False)
    waktu = forms.DateTimeField(input_formats=['%d/%m/%Y %H:%M'], required=False)
    status_pengantaran= forms.CharField(label='Status Pengantaran', max_length=20, required=False)
    biaya_kirim = forms.IntegerField(label='Biaya Kirim', required=False)

pengantaranfarmasi/views.py
from django.shortcuts import render, reverse, redirect
from django.contrib.auth.models import User, Permission
from django.contrib.auth import update_session_auth_hash
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib.auth import authenticate, logout, login

from django.conf.urls.static import static

from .forms import PFForm, updatePFForm
import pandas as pd
from django_tables2.tables import Table
from django.contrib.staticfiles import finders
from django.contrib.staticfiles.storage import staticfiles_storage

from farmakami.settings import STATIC_DIR
import os
from django.db import connection
from collections import namedtuple


def namedtuplefetchall(cursor):
    "Return all rows from a cursor as a namedtuple"
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]

def createPF(request):
    message = ''
    if request.method =='POST':
        id_transaksi_pembelian = request.POST["id_transaksi_select"]
        biaya_kirim = request.POST.get("biaya_kirim")
        waktu = request.POST["waktu"]
        cursor = connection.cursor()
        if int(biaya_kirim)> 0:
            sumid = "select count(*) from farmakami.pengantaran_farmasi"
            cursor.execute(sumid)
            sumidfix = cursor.fetchone()[0]

            test = "PTR" + str(sumidfix)
            sql_test = "select count(*) from farmakami.pengantaran_farmasi where id_pengantaran ='" + test + "'"
            cursor.execute(sql_test)
            hasil = cursor.fetchone()[0]

            while(hasil != 0):
                sumidfix = sumidfix + 1
                test = "PTR" + str(sumidfix)
                sql_test = "select count(*) from farmakami.pengantaran_farmasi where id_pengantaran ='" + test + "'"
                cursor.execute(sql_test)
                hasil = cursor.fetchone()[0]

            fix_id = "PTR" + str(sumidfix)
            #Sampe sini
            temp_kurir = 'K1'
            temp_status = 'Processing'
            sql_bp = "insert into farmakami.pengantaran_farmasi VALUES (%s, %s, %s, %s, %s, %s, %s);"
            cursor.execute(sql_bp,(fix_id, temp_kurir, id_transaksi_pembelian, waktu, temp_status, biaya_kirim, 0))

            return redirect('/pengantaranfarmasi/listPF')
        else :
            message = "Biaya kurang dari 0"

    form = PFForm()
    cursor = connection.cursor()
    sql_idtransaksi = "select distinct id_transaksi_pembelian from farmakami.transaksi_pembelian ORDER BY id_transaksi_pembelian ASC"
    cursor.execute(sql_idtransaksi)
    idtransaksi = namedtuplefetchall(cursor)
    args = {'form': form, 'idtransaksi': idtransaksi, 'message':message}
    return render(request, 'createpf.html', args)

def listPF(request):
    email = request.session['email']
    dataset = []
    cursor = connection.cursor()
    if request.session['role'] == 'kurir':
        sql_search_kurir= "select id_kurir from farmakami.kurir where email = '" + email + "';"
        cursor.execute(sql_search_kurir)
        id_kurir = cursor.fetchone()[0]
        print(id_kurir)
        sql_all_PF= "select * from farmakami.pengantaran_farmasi where id_kurir = '" + id_kurir + "' "
        cursor.execute(sql_all_PF)
        dataset = namedtuplefetchall(cursor)
    else:
        print('masuk')
        sql_all_PF= "select * from farmakami.pengantaran_farmasi ORDER BY id_pengantaran ASC"
        cursor.execute(sql_all_PF)
        dataset = namedtuplefetchall(cursor)
    context = {'table': dataset}
    return render(request, "listPF.html", context)

def updatePF(request, id):
    message = ''
    if request.method == "POST":
        id_kurir = request.POST["id_kurir_select"]
        id_transaksi_pembelian = request.POST["id_transaksi_select"]
        biaya_kirim = request.POST.get("biaya_kirim")
        waktu = request.POST["waktu"]
        status_pengantaran = request.POST.get("status_pengantaran")
    
        cursor = connection.cursor()
        print(waktu)
        if str(biaya_kirim) == '' or int(biaya_kirim)>= 0:
            if waktu != "":
                sql = "update farmakami.pengantaran_farmasi set waktu ='" + waktu +"' where id_pengantaran ='" + id + "';"
                cursor.execute(sql)

            if id_kurir != "none":
                sql = "update farmakami.pengantaran_farmasi set id_kurir ='" + id_kurir +"' where id_pengantaran ='" + id + "';"
                cursor.execute(sql)
            
            if id_transaksi_pembelian != "none":
                sql = "update farmakami.pengantaran_farmasi set id_transaksi_pembelian ='" + id_transaksi_pembelian +"' where id_pengantaran ='" + id + "';"
                cursor.execute(sql)
            
            if biaya_kirim != "":
                sql = "update farmakami.pengantaran_farmasi set biaya_kirim ='" + biaya_kirim +"' where id_pengantaran ='" + id + "';"
                cursor.execute(sql)
            
            if status_pengantaran != "":
                sql = "update farmakami.pengantaran_farmasi set status_pengantaran ='" + status_pengantaran +"' where id_pengantaran ='" + id + "';"
                cursor.execute(sql)
            return redirect('/pengantaranfarmasi/listPF')
        else:
            message = 'Biaya kurang dari 0'
        
        
    form = updatePFForm()
    cursor = connection.cursor()
    sql_idtransaksi = "select distinct id_transaksi_pembelian from farmakami.transaksi_pembelian ORDER BY id_transaksi_pembelian ASC"
    cursor.execute(sql_idtransaksi)
    idtransaksi = namedtuplefetchall(cursor)
    sql_idkurir = "select distinct id_kurir from farmakami.kurir ORDER BY id_kurir ASC"
    cursor.execute(sql_idkurir)
    idkurir = namedtuplefetchall(cursor)
    sql_biaya = "select total_biaya from farmakami.pengantaran_farmasi WHERE id_pengantaran = '" + id +"';"
    cursor.execute(sql_biaya)
    biaya_sql = namedtuplefetchall(cursor)
    biaya = biaya_sql[0].total_biaya
    args = {'form': form, 'idtransaksi': idtransaksi, 'idkurir': idkurir, "id":id, "biaya":biaya, 'message':message}
    return render(request, "updatepf.html", args)


def deletePF(request, id):
    cursor = connection.cursor()
    print(id)
    sql_delete_PF= "delete from farmakami.PENGANTARAN_FARMASI where id_pengantaran = '" +  id + "'"
    cursor.execute(sql_delete_PF)
    return redirect('/pengantaranfarmasi/listPF')

pengantaranfarmasi/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>FarmaKami</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/css/all.min.css">
</head>

<body>
    <div class="jumbotron m-5">
        {% block content %}
        {% endblock content %}
    </div>
    
    <br><br>
    <hr class="my-4">

    <a href="{% url 'login:homepage' %}" class="btn btn-outline-primary" role="button">Homepage</a>
    <a href="{% url 'login:logout' %}" class="btn btn-outline-primary" role="button">Logout</a>


    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
        integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
        integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
        integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
        crossorigin="anonymous"></script>
</body>
</html>

pengantaranfarmasi/templates/createpf.html
{% extends "base.html" %}

{% block content %}

<div class="container">  
    <small class="text-muted">{{ message }}</small> <br><br> 
    
<h1 class="display-4">Create Pengantaran Farmasi</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<div class="container">         
    <form method="post">
        {% csrf_token %}
        <label>ID Transaksi Pembelian: </label>
        <select id="id_transaksi_select" name="id_transaksi_select">
            <option value="none">none</option>
            {% for id in idtransaksi %}
               <option value={{id.id_transaksi_pembelian}}>{{id.id_transaksi_pembelian}}</option>
            {% endfor %}
        </select>
        <br>
        <label>Biaya Kirim: </label>
        {{form.biaya_kirim}} <br>
        <label>Waktu: </label>
        <input type="datetime-local" id="waktu_select" name="waktu" value="{{ form.waktu.value }}">
        <br><button class="btn btn-outline-primary" type="submit">Submit</button>
    </form>
</div>

<style>
    input, select {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

{% endblock content %}

pengantaranfarmasi/templates/listPF.html
{% extends "base.html" %}

{% block content %}

<h1 class="display-4">List Pengantaran Farmasi</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<table class="table table-striped table table-hover">
    <thead>
      <tr>
        <th scope="col">Id Pengantaran</th>
        <th scope="col">Id Kurir</th>
        <th scope="col">Id Transaksi Pembelian</th>
        <th scope="col">Waktu </th>
        <th scope="col">Status Pengantaran </th>
        <th scope="col">Biaya Kirim </th>
        <th scope="col">Total Biaya </th>
        {% if request.session.role == 'admin_apotek' %}
        <th scope="col" colspan="2" style="text-align: center;" > Edit </th>
        {% endif %}
      </tr>
    </thead>
    <tbody>
    {% for item in table %}
      <tr>
        <td>{{ item.id_pengantaran }}</td>
        <td>{{ item.id_kurir }}</td>
        <td>{{ item.id_transaksi_pembelian }}</td>
        <td>{{ item.waktu }}</td>
        <td>{{ item.status_pengantaran }}</td>
        <td>{{ item.biaya_kirim }}</td>
        <td>{{ item.total_biaya }}</td>
        {% if request.session.role == 'admin_apotek' %}
        <td><a href="{% url 'pengantaranfarmasi:updatePF' item.id_pengantaran %}" class="btn btn-outline-primary" role="button">Update</a></td>
        <td><a href="{% url 'pengantaranfarmasi:deletePF' item.id_pengantaran %}" class="btn btn-outline-primary" role="button">Delete</a></td>
        {% endif %}
      </tr>
      {% endfor %}
    </tbody>
  </table>



{% endblock content %}

pengantaranfarmasi/templates/updatepf.html
{% extends "base.html" %}

{% block content %}
<div class="container">  
    <small class="text-muted">{{ message }}</small> <br><br> 
<h1 class="display-4">Update Pengantaran Farmasi</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<div class="container">    
      
    <form method="post">
        <label>ID Pengantaran: </label>  
        <input type="text" name="id_transaksi" item="id_transaksi" style="background-color: #C8C8C8; " value= {{ id }} disabled> 
        <br>
        {% csrf_token %}
        <label>ID Kurir: </label>
        <select id="id_kurir_select" name="id_kurir_select">
            <option value="none">none</option>
            {% for id in idkurir %}
               <option value={{id.id_kurir}}>{{id.id_kurir}}</option>
            {% endfor %}
        </select>
        <br><label>ID Transaksi Pembelian: </label>
        <select id="id_transaksi_select" name="id_transaksi_select">
            <option value="none">none</option>
            {% for id in idtransaksi %}
               <option value={{id.id_transaksi_pembelian}}>{{id.id_transaksi_pembelian}}</option>
            {% endfor %}
        </select>
        <br>
        <label>Waktu: </label>
        <input type="datetime-local" id="waktu_select" name="waktu" value="{{ form.waktu.value }}">
        <br><label>Status Pengantaran: </label>
        {{form.status_pengantaran}} <br>
        <label>Biaya Kirim: </label>
        {{form.biaya_kirim}} <br>
        <label>Total Biaya: </label> 
        <input type="text" name="total_biaya" item="total_biaya" style="background-color: #C8C8C8; " value= {{ biaya }} disabled> 
        <br>
        <button class="btn btn-outline-primary" type="submit">Update</button>
    </form> 
</div>

<style>
    input, select, .temp {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

{% endblock content %}